public class Sphere implements cObject
{
	byte bType=0, bFlag=0;
	String sName;
	cVector oLocation, oVect1, oVect2, oVect3=null, oLower=null, oUpper=null, oNorm=null;
	double dN=0, dLen1=0, dLen2=0, dCos1=0, dCos2=0, dSin1=0, dSin2=0, dXmult=0, dYmult=0;
	cColor oColor=null;
	cObject next;
	cRayConst oRayConst=null;
	
	Sphere(cVector loc, double r){
		bType=1;
        this.sName="SPHERE";
		oLocation=loc;
		dXmult=1;
		dYmult=1;
		oUpper=new cVector();
		oLower=new cVector();
		oVect1=new cVector(r,0,0);
		dN=r*r;
		oColor=new cColor();
		next=null;
	}

	Sphere(double x, double y, double z, double r){
		bType=1;
        sName="SPHERE";
		oLocation=new cVector(x,y,z);
		dXmult=1;
		dYmult=1;
		oUpper=new cVector();
		oLower=new cVector();
		oVect1=new cVector(r,0,0);
		dN=r*r;
		oColor=new cColor();
		next=null;
	}

	public void setAmb(cVector col){
		oColor.oAmb=col;
	}

	public void setDiff(cVector col){
		oColor.oDiff=col;
	}

	public void setTrans(cVector col){
		oColor.oTrans=col;
	}
	
	public void setDensity(cVector col){
		oColor.oDensity=col;
	}

	public void setNext(cObject o){next=o;}
	
	public cObject getNext(){return next;}

	public String name(){return sName;}

	public cVector oVect1(){return oVect1;}

	public cColor oColor(){return oColor;}
	
	public void findNorm(cVector oNormal, cVector oPosition){
		oNormal.setDiff(oPosition,oLocation);
		oNormal.norm();
	}
	
	public void position(double [] dPos, cVector oLoc){
		cVector delta=new cVector();
		delta.setDiff(oLoc,oLocation);
		dPos[0]=Math.atan2(delta.x,delta.y)*oVect1.x;
		dPos[1]=Math.atan2(Math.sqrt(delta.x*delta.x+delta.y*delta.y),delta.z)*oVect1.x;
	}
	
	public double collisionTest(cLine oLine){
		double t=-1;
		double a,b,c,d,t1;
		cVector temp=new cVector();
		
		temp.setDiff(oLocation, oLine.oLocation);
		c=temp.dot(temp)-dN;
		b=-2*oLine.oDir.dot(temp);
		a=oLine.oDir.dot(oLine.oDir);
		d=b*b-4*a*c;
		if(d<=0){/*System.out.println("returning -1");*/ return -1;}
		d=Math.sqrt(d);
		t=(-b+d)/(a+a);
		t1=(-b-d)/(a+a);
		if((t<oRayConst.SMALL) && (t<oRayConst.SMALL))
			return -1;
		if(t1>t){
			if(t<oRayConst.SMALL);
			t=t1;
		} else
			if(t>t1) t=t1;
		return t;
	}
	
	public void findBbox(cVector oV1, cVector oV2){//This seems strange - always using x!
		oV1.x=oLocation.x-oVect1.x;
		oV2.x=oLocation.x+oVect1.x;
		oV1.y=oLocation.y-oVect1.x;
		oV2.y=oLocation.y+oVect1.x;
		oV1.z=oLocation.z-oVect1.x;
		oV2.z=oLocation.z+oVect1.x;
	}
	
}
