public class cRayTrace
{
	cRayConst oRayConst=null;
	cWorld oWorld=null;
	int iLevel;
	graphicsScreen oScreen;
	
	cRayTrace(cWorld w, cRayConst c, graphicsScreen os){
		oWorld=w;
		oRayConst=c;
		oScreen=os;
	}
	
	void trace(){
		int x,y;
		int [] bRed=new int[oWorld.iHorSize];
		int [] bGreen=new int[oWorld.iHorSize];
		int [] bBlue=new int[oWorld.iHorSize];
		double xf,yf;
		cLine oLine=new cLine();
		
		for(y=0;y<oWorld.iVertSize;y++){
			yf=(oWorld.centerY-y)/(oWorld.fVertSize);
			for(x=0;x<oWorld.iHorSize;x++){
				cVector oColor=new cVector();
				xf=(oWorld.centerX-x)/(oWorld.fVertSize*oWorld.dAspect);
				oLine.oLocation=oWorld.oObsLoc.copy();
				oLine.oDir=oWorld.oObsDir.copy();
				cVector tmp=new cVector();
				tmp.setProd(oWorld.oObsRight,xf);
				oLine.oDir.setSum(oLine.oDir, tmp);
				tmp.setProd(oWorld.oObsUp,yf);
				oLine.oDir.setSum(oLine.oDir, tmp);
				iLevel=0;
				//if(y==10)System.out.println(oLine.oDir+" "+oLine.oLocation);
				TraceRay(oLine, oColor, 1.0);
				oWorld.iPrimTraced++;
				//System.out.println(oColor);
				bRed[x]=(int)oColor.x%255;
				bGreen[x]=(int)oColor.y%255;
				bBlue[x]=(int)oColor.z%255;
			}
			DumpLine(y, bRed, bGreen, bBlue);
		}
	}
	
	void TraceRay(cLine oLine, cVector oColor, double multiplier){
		cVector oNewPos=new cVector(), oNewDir=new cVector(), oClosestObjLoc=new cVector(), oClosestObjNorm=new cVector();
		double dShortestTime, divisor;
		cObject oClosestObj;
		cColor oColorData=new cColor();
		cVector loc=new cVector();		
		
		iLevel++;
		if(iLevel>48)return;
		if(multiplier<oWorld.dThreshold)return;
		double [] oST=new double[1];
		oClosestObj=Intersect(oWorld.oObject, oLine, oST, false, null);
		dShortestTime=oST[0];
		if(oClosestObj!=null){
			cVector tmp=new cVector();
			tmp.setProd(oLine.oDir, dShortestTime);
			loc.setSum(oLine.oLocation, tmp);
			oClosestObj.findNorm(oClosestObjNorm, loc);
			if(oClosestObjNorm.dot(oLine.oDir)>0)
				oClosestObjNorm.setNeg();
			oColorData=oClosestObj.oColor().copy();
			//System.out.println("Setting color "+oColorData.oAmb);
			AmbientColor(oColor, oColorData, oClosestObjNorm,oClosestObjLoc); 
			DiffuseColor(oColor, oColorData, oClosestObjNorm,oClosestObjLoc, oLine); 
			//TransparentColor(oColor, oColorData, oClosestObjNorm,oClosestObjLoc, oLine, multiplier); 
			//ReflectColor(oColor, oColorData, oClosestObjNorm,oClosestObjLoc, oLine, multiplier); 
		} else {
			SkyColor(oLine, oColor);
		}
		if((oColor.x>oRayConst.iCNUM) || (oColor.y>oRayConst.iCNUM) || (oColor.z>oRayConst.iCNUM)){
			divisor=oColor.max()/oRayConst.fCNUM;
			oColor.div(divisor);
		}
		return;		
	}
		
	
	cObject Intersect(cObject oObject, cLine oLine, double [] oShortestTime, boolean bShadow, cVector oAttn){
		cObject oClosestObj=null;
		cVector oLoc;
		cObject oObj;
		int collision;
		double t;

		oObj=oObject;
		double dShortestTime=3e30;

		while(oObj!=null){
			t=oObj.collisionTest(oLine);
			if(t>oRayConst.SMALL){
				oWorld.rayIntersects++;
				if((bShadow) && (t<1)){
					if((oObj.oColor().oTrans.x<oWorld.dThreshold) && (oObj.oColor().oTrans.y<oWorld.dThreshold) && (oObj.oColor().oTrans.z<oWorld.dThreshold)){
						return oObj;
					}
					if(oAttn!=null){
						cVector tmp=oObj.oColor.oTrans.copy();
						tmp.setProd(tmp,tmp);
						tmp.setDiv(tmp, oRayConst.fCNUM*oRayConst.fCNUM);
						oAttn.setProd(oAttn, tmp);
					}
				}
				if((!bShadow) && (t<dShortestTime)){
					dShortestTime=t;
					oClosestObj=oObj;
				}
			}
			oObj=oObj.getNext();
		}	
		oShortestTime[0]=dShortestTime;
		return oClosestObj;
	}
	
	void AmbientColor(cVector oColor, cColor oColorData, cVector oNorm, cVector oLoc){
		cVector temp=oColorData.oDiff.copy();
		//temp.div(oRayConst.fCNUM);
		temp.setProd(temp,oColorData.oAmb);
		oColor.add(temp);
	}
	
	void DiffuseColor(cVector oColor, cColor oColorData, cVector oNorm, cVector oLoc, cLine oLine){
		cLine line=new cLine();
		cObject oCurrObj;
		cLamp oLamp;
		double dot, distance, t1=0, t2;
		double [] time=new double[1];
		cVector reflect, attenuate;
		
		line.oLocation=oLoc;
		oLamp=oWorld.oLamps;
		while(oLamp!=null){
			line.oDir.setDiff(oLamp.oLoc,oLoc);
			attenuate=new cVector(1,1,1);
			oCurrObj=Intersect(oWorld.oObject, line, time, true, attenuate);
			if(oCurrObj==null){
				distance=line.oDir.dot(line.oDir);
				line.oDir.setNeg();
				if((oColorData.oDiff.x>0) || (oColorData.oDiff.y>0) || (oColorData.oDiff.z>0)){
					t1=oNorm.dot(line.oDir);
					if(t1>0){
						t2=oLamp.distance*t1/Math.sqrt(distance);
						cVector tmp=attenuate.copy();
						tmp.setProd(tmp, oColorData.oDiff);
						tmp.setProd(tmp,t2);
						oColor.add(tmp);
					}
				}
				if(oColorData.dReflect>0){
					dot=line.oDir.dot(oNorm);
					reflect=line.oDir.copy();
					cVector tmp=new cVector();
					tmp.setProd(reflect, dot);
					tmp.add(tmp);
					reflect.add(tmp);
					t1=-(reflect.dot(oLine.oDir));
					if(t1>0.6){
						t2=Math.pow(t1, oColorData.dReflect)*oLamp.distance/Math.sqrt(distance);
						t2*=oColorData.dReflect;
						attenuate.setProd(attenuate, t2);
						oColor.add(attenuate);
					}
				}
			}
		oLamp=oLamp.next;
		}
	}
	
	void TransparentColor(cVector oColor, cColor oColorData, cVector oNorm, cVector oLoc, cLine oLine, double multiplier){
	//READY FOR THIS
	}

	void ReflectColor(cVector oColor, cColor oColorData, cVector oNorm, cVector oLoc, cLine oLine, double multiplier){
		

	}

	void SkyColor(cLine oLine, cVector oColor){
		double length, horiz, zenith;
		
		length=oLine.oDir.dot(oLine.oDir);
		zenith=(oLine.oDir.y*oLine.oDir.y)/length;
		horiz=(oLine.oDir.x*oLine.oDir.x+oLine.oDir.z*oLine.oDir.z)/length;
		cVector tmp=new cVector();
		tmp.setProd(oWorld.skyColorZenith,zenith);
		//System.out.println("Zskycolor "+oWorld.skyColorZenith+" "+zenith);
		oColor.add(tmp);
		tmp.setProd(oWorld.skyColorHoriz,horiz);
		oColor.add(tmp);
		//System.out.println("Set to skycolor"+oColor);
		//Dither(color, WORLD.dSkyDither);
	}

	void DumpLine(int y, int [] bRed, int [] bGreen, int [] bBlue){
		//System.out.println(y);
		for(int i=0; i<bRed.length; i++){
			//System.out.println("Color is "+((bRed[i]<<16)|(bGreen[i]<<8)|bBlue[i])+" == "+(200<<16));
			oScreen.plotRGB(i,y,((bRed[i]<<16)|(bGreen[i]<<8)|bBlue[i]));
		}
		oScreen.paintBuffer();
	}
}