public class cVector
{
	double x,y,z;
	
	cVector(){
		x=y=z=0;
	}

	cVector(double x, double y, double z){
		this.x=x;
		this.y=y;
		this.z=z;
	}
	
	cVector(cVector oVector){
		x=oVector.x;
		y=oVector.y;
		z=oVector.z;
	}
	
	cVector copy(){
		return new cVector(this);
	}
	
	double max(){
		double tm;
		tm=Math.max(x,y);
		return Math.max(tm,z);
	}
	
	void add(cVector o){
		x+=o.x;
		y+=o.y;
		z+=o.z;
	}

	void setSum(cVector o1, cVector o2){
		x=o1.x+o2.x;
		y=o1.y+o2.y;
		z=o1.z+o2.z;
	}

	void setDiff(cVector o1, cVector o2){
		x=o1.x-o2.x;
		y=o1.y-o2.y;
		z=o1.z-o2.z;
	}
	
	void setNeg(){
		this.x=-x;
		this.y=-y;
		this.z=-z;
	}
	
	void setProd(cVector o1, cVector o2){
		x=o1.x*o2.x;
		y=o1.y*o2.y;
		z=o1.z*o2.z;
	}
	
	void setProd(cVector o1, double c){
		x=o1.x*c;
		y=o1.y*c;
		z=o1.z*c;
	}
	
	void setDiv(cVector o1, double c){
		x=o1.x/c;
		y=o1.y/c;
		z=o1.z/c;
	}
	
	void div(double c){
		x/=c;
		y/=c;
		z/=c;
	}
	
	void set(cVector o){
		x=o.x;
		y=o.y;
		z=o.z;
	}
	
	double dot(cVector o){
		return x*o.x+y*o.y+z*o.z;
	}
	
	void setCross(cVector o1, cVector o2){
		x=o1.y*o2.z-o1.z*o2.y;
		y=o1.z*o2.x-o1.x*o2.z;
		z=o1.x*o2.y-o1.y*o2.x;
	}
	
	void norm(){
		double l=Math.sqrt(x*x+y*y+z*z);
		x/=l;
		y/=l;
		z/=l;
	}
	
	void setMax(cVector o1, cVector o2){
		x=Math.max(o1.x,o2.x);
		y=Math.max(o1.y,o2.y);
		z=Math.max(o1.z,o2.z);
	}
	
	void setMin(cVector o1, cVector o2){
		x=Math.min(o1.x,o2.x);
		y=Math.min(o1.y,o2.y);
		z=Math.min(o1.z,o2.z);
	}
	
	void rotate(double cos1, double sin1, double cos2, double sin2){
		double ty,tz;
		
		ty=y;
		tz=x*sin1+z*cos1;
		x=x*cos1+z* -sin1;
		y=ty* -cos2+tz*sin2;
		z=ty* -sin2+tz* -cos2;
	}

	void revRotate(double cos1, double sin1, double cos2, double sin2){
		double tx,tz;
		
		tx=x;
		tz=y*sin2+z*cos2;
		x=tx*-cos1+tz* -sin1;
		y=y*cos2+z*-sin2;
		z=tx* -sin1+tz* -cos1;
	}

	public String toString(){
		return "("+x+","+y+","+z+")";
	}
}
