import java.awt.*;
import java.awt.image.*;

class graphicsScreen extends java.awt.Frame
{

    Graphics g;
  	int width, height;
    private Canvas canvas;
    private BufferedImage buffer;

    /** Creates new graphicsScreen with specified dimensions */
    public graphicsScreen(int xsize, int ysize)
    {
		this(xsize, ysize, "Graphics Screen");
    }

    /** Creates new graphicsScreen with specified dimensions and title */
    public graphicsScreen(int xsize, int ysize, String title)
    {
        // old initComponents:
        canvas = new java.awt.Canvas ();
        setLayout (new java.awt.FlowLayout ());

        addWindowListener (new java.awt.event.WindowAdapter ()
        					{
								public void windowClosing (java.awt.event.WindowEvent evt)
								{
									exitForm (evt);
								}
							}
						  );

        canvas.setBackground (java.awt.Color.white);
        canvas.setName (title);
        add (canvas);
        // end initComponents

        canvas.setBounds(0,0, xsize, ysize);
        pack(); // Causes Window to be sized to the preferred size and layouts
        buffer = (BufferedImage) canvas.createImage(xsize, ysize);
        g=canvas.getGraphics();
        g.setClip(0,0,xsize,ysize);
        width=xsize;
        height=ysize;
        clear();
		show();
    }

    public void plotColor(int x, int y, Color c)
    {
        buffer.setRGB(x, y, c.getRGB() );
    }

    public void plotRGB(int x, int y, int RGBvalue)
    {
        buffer.setRGB(x, y, RGBvalue );
    }

    public void plotRGBline(int y, int[] rgbLine)
    {
	for(int x=0; x<rgbLine.length; x++)
	    buffer.setRGB(x, y, rgbLine[x] );
    }

    public void paintBuffer()
    {
        g.drawImage(buffer, 0, 0, null);
    }



	public void clear()
	{
		g.setColor(Color.white);
        g.fillRect(0,0,width,height);
	}

    private void exitForm(java.awt.event.WindowEvent evt)
    { //GEN-FIRST:event_exitForm
        System.exit (0);
    }
}
